/* -*- Mode: C++ -*- */

/* This is a quick little test program for my RuleStorage class
   which also illustrates how to use this */

#include <iostream>
#include "RuleStorage.h"

class MyRule
{
public:
  MyRule(const std::string& s) : s(s) {}

  friend std::ostream& operator<<(std::ostream& os, const MyRule& r)
  { os << r.s; return os; }
  
  std::string s;
};

std::ostream&
operator<<(std::ostream& os, const MyRule* pr)
{
  if (pr)
    os << *pr;
  else
    os << "NULL";
  return os;
}

void
printRules(const char* prefix, const RuleStorage<MyRule>& store)
{
  std::cout << prefix << ": rule1: " << store.lookup("rule1") << std::endl;
  std::cout << prefix << ": rule2: " << store.lookup("rule2") << std::endl;
  std::cout << prefix << ": rule3: " << store.lookup("rule3") << std::endl;
  std::cout << prefix << ": rule4: " << store.lookup("rule4") << std::endl;
  std::cout << prefix << ": rule5: " << store.lookup("rule5") << std::endl;
  std::cout << prefix << ": rule6: " << store.lookup("rule6") << std::endl;
  std::cout << prefix << ": ruleNOT: " << store.lookup("ruleNOT") << std::endl;
}


int
main (int argc, char** argv)
{
  RuleStorage<MyRule> store;
  MyRule rule1("RULE1");
  MyRule rule2("RULE2");
  MyRule rule3("RULE3");
  MyRule rule4("RULE4");
  MyRule rule5("RULE5");
  MyRule rule6("RULE6");

  store.insert("rule1", &rule1);
  printRules("#1", store);
  
  store.insert("rule2", &rule2);
  printRules("#2", store);
    
  store.insert("rule3", &rule3);
  store.insert("rule4", &rule4);
  printRules("#3", store);
    
  store.erase("rule1");
  store.erase("rule2");
  printRules("#4", store);
    
  store.insert("rule5", &rule5);
  store.insert("rule6", &rule6);
  printRules("#5", store);
}
