/*
 * ColorTableItem subclasses QTableItem in order to allow us to set 
 *  foreground and background colors on table cells. 
 *
 * Author: John Davin
 */


#ifndef COLORTABLEITEM_H
#define COLORTABLEITEM_H

#include <qtable.h>



class ColorTableItem : public QTableItem  {
public:         
    ColorTableItem(QTable *t, EditType et, const QString txt, QColor fg, QColor bg);
    ~ColorTableItem();

private:
    void ColorTableItem::paint( QPainter *p, const QColorGroup &cg, const QRect &cr, bool selected );

    QColor fgcolor;
    QColor bgcolor;

};



#endif



