/* Dongryeol Lee
 *
 * ApplicabilityActionVisitor.h
 *
 * Given an action advice, the ApplicabilityActionVisitor class will determine
 * whether the advice is applicable to the current situation.
 *
 */


#ifndef APPLICABILITY_ACTION_VISITOR
#define APPLICABILITY_ACTION_VISITOR

#include "visitor.h"
#include "clangaction.h"


class ApplicabilityActionVisitor: public rcss::clang::Action::Visitor
{
 public:
  
  /* Return whether the action is applicable or not */
  bool getApplicability() const { return IsApplicable; }

 private:
  /* Visit methods */
  void visit(rcss::clang::ActPos *act);

  void visit(rcss::clang::ActHome *act);
  
  void visit(rcss::clang::ActBallToReg *act);
  
  void visit(rcss::clang::ActBallToPlayer *act);
  
  void visit(rcss::clang::ActMark *act);
  
  void visit(rcss::clang::ActMarkLinePlayer *act);
  
  void visit(rcss::clang::ActMarkLineReg *act);

  void visit(rcss::clang::ActOffsidesLine *act);

  void visit(rcss::clang::ActHetType *act);

  void visit(rcss::clang::ActNamed *act);

  void visit(rcss::clang::ActPassReg *act);

  void visit(rcss::clang::ActPassUNum *act);

  void visit(rcss::clang::ActDribble *act);

  void visit(rcss::clang::ActClear *act);

  void visit(rcss::clang::ActShoot *act);

  void visit(rcss::clang::ActHold *act);

  void visit(rcss::clang::ActIntercept *act);

  void visit(rcss::clang::ActTackle *act);
  
  bool IsApplicable;

};


#endif
