/*
 * MySayMsgFactory.h - Defines a subclass of SayMsgFactory
 *   to return our subclassed message types (which are in MySayMsgTypes.h). 
 *
 * Creation Date: 12/4/03
 * Author: John Davin
 *
 *
 *
 */


#ifndef MY_SAY_MSG_FACTORY_H
#define MY_SAY_MSG_FACTORY_H


#include "MySayMsgTypes.h"


/*
 * Returns our subclasses which are defined in MySayMsgTypes.h
 *
 */
class MySayMsgFactory : public SayMsgFactory {

 public:
  OurPos *getOurPos(){ return new MyOurPos(); }

  BallPos *getBallPos(){ return new MyBallPos(); }

  BallVel *getBallVel(){ return new MyBallVel(); }

  WeHaveBall *getWeHaveBall(){ return new MyWeHaveBall(); }

  OppHasBall *getOppHasBall(){ return new MyOppHasBall(); }

  PassToPlayer *getPassToPlayer(){ return new MyPassToPlayer(); }

  PassToCoord *getPassToCoord(){ return new MyPassToCoord(); }

  WantPass *getWantPass(){ return new MyWantPass(); }

  OppPos *getOppPos(){ return new MyOppPos(); }

  TeammatePos *getTeammatePos(){ return new MyTeammatePos(); }


};



#endif


