/* -*- Mode: c++ -*- */

/* this little class helps with the logging */

#ifndef _PLAYERTAGFUNCTION_H_
#define _PLAYERTAGFUNCTION_H_

#include <string>
#include "Logger.h"
#include "utility.h"
#include "WorldModel.h"

class PlayerTagFunction
:public spades::TagFunction
{
public:
  PlayerTagFunction (WorldModel* wm) : wm(wm) { }
  std::string getTag (int level) const
  { std::string s; s.insert (s.end (), level / 10, '-');
  return (wm ? wm->getCurrentTime().toString() : "I") + " " + s;  }
  std::string getErrorTag (int level) const
  {
    return (level == 0 ? "PlayerError " : ("PlayerWarning[" + spades::toString(level) + "] ")) +
      spades::toString(wm ? wm->getPlayerNumber() : -1) + ": ";
  }
  void forgetWorldModel() { wm = NULL; }
private:
  WorldModel* wm;
};

#endif
