/* 
 * a global header containing definitions/settings and macros
 * Put in this file if it needs to be easily accessible. 
 *
 */

#ifndef CONFIG_H
#define CONFIG_H

#include "UvaLogger.h"
#include "ServerSettings.h"


// the name for the rules file. used in PlayerInterface.C
#define RULES_FILE "rules.txt"
#define PR Log.log // shortcut for less typing
#define LOGOUT(X) if(Log.isInLogLevel(X)) Log.getOutputStream()

// give access to the Log: 
extern Logger Log;
extern ostream *logger;
//extern ofstream execd_action_log; // from main.C
extern ofstream rulelog; // from main.C

using namespace rcss;
using namespace clang;


// maximum recursive depth (of variables) a UNumSet can have
#define MAX_VARIABLE_EXPANSIONS 15

// the logging level used for error and warning messages
#define ERROR_LOGLEVEL 9

#endif // CONFIG_H
