/*
    Coachable Agent communication encoding and decoding library
    Copyright (C) 2004, John Davin, Carnegie Mellon University

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/

/*
 * charConversionHelper.h - contains some simple character conversion functions 
 *  which are used by SayMsgTypes.h and SayMsgDecoder. 
 *
 *
 * Creation Date: 11/18/03
 * Author: John Davin
 *
 *
 */


#ifndef CHAR_CONVERSION_HELPER_H
#define CHAR_CONVERSION_HELPER_H


const char validchars[] = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ().+-*/?<>_";
#define NUMCHARS 73 // validchars has 73 chars (so max array index is NUMCHARS-1)



/*
 * returns the index into the validchars array for char c 
 * Returns -1 on error (eg, char c is not in validchars)
 */
short get_num_from_char(char c);



/* helper function for SayMsgTypes::getEncodedStr(): 
 * Given i, an index into validchars array, returns the appropriate char. 
 * If i is out of bounds, rounds to nearest bound. 
 */
char get_printable_char(float i);



#endif
