/*
 * Logging_SayMsgFactory.h - Defines a subclass of SayMsgFactory
 *   to return our subclassed message types. 
 *
 * Creation Date: 11/18/03
 * Author: John Davin
 *
 *
 *
 */


#ifndef LOGGING_SAY_MSG_FACTORY_H
#define LOGGING_SAY_MSG_FACTORY_H


#include "Logging_SayMsgTypes.h"


/*
 * Returns our subclasses which are defined in Logging_SayMsgTypes.h
 *
 */
class Logging_SayMsgFactory : public SayMsgFactory {

 public:
  OurPos *getOurPos(){ return new MyOurPos(); }

  BallPos *getBallPos(){ return new MyBallPos(); }

  BallVel *getBallVel(){ return new MyBallVel(); }

  WeHaveBall *getWeHaveBall(){ return new MyWeHaveBall(); }

  OppHasBall *getOppHasBall(){ return new MyOppHasBall(); }

  PassToPlayer *getPassToPlayer(){ return new MyPassToPlayer(); }

  PassToCoord *getPassToCoord(){ return new MyPassToCoord(); }

  WantPass *getWantPass(){ return new MyWantPass(); }

  OppPos *getOppPos(){ return new MyOppPos(); }

  TeammatePos *getTeammatePos(){ return new MyTeammatePos(); }


};





#endif


